package com.snplog.backend.dao;

import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.NoResultException;

import org.hibernate.Session;
import org.hibernate.query.Query;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;

import com.snplog.backend.entity.MyUser;

@Repository
public class MyUserDAOImpl implements MyUserDAO {

	@Autowired
	private EntityManager entityManager;
	
	@Override
	public List<MyUser> findAll() {

		Session session = entityManager.unwrap(Session.class);
		
		Query<MyUser> query = session.createQuery(
				"from MyUser", MyUser.class
				);
		
		List<MyUser> users = query.getResultList();
		
		return users;
	}

	// TODO change so that email is primary key (?)
	// this allows multiple users on one email
	// could cause problems
	@Override
	public MyUser getMyUserByEmail(String email) {
		
		try {
			Session session = entityManager.unwrap(Session.class);
			
			Query<MyUser> query = session.createQuery(
					"Select u from MyUser u where u.email=:userEmail",
					MyUser.class
					);
			query.setParameter("userEmail", email);
			
			MyUser myUser = query.getSingleResult();
					
			
			return myUser;
		} catch (NoResultException e) {
			System.out.println("No user found for " + email + "\n\n\n" + e);
			return null;
		}
		
	}

	@Override
	public void updateMyUser(MyUser myUser) {
		Session session = entityManager.unwrap(Session.class);
		session.saveOrUpdate(myUser);
		
	}

	@Override
	public void createMyUser(MyUser myUser) {
		Session session = entityManager.unwrap(Session.class);
		session.save(myUser);
		
	}

	@Override
	public void deleteMyUser(MyUser myUser) {
		
		Session session = entityManager.unwrap(Session.class);

		Query query = session.createQuery(
				"delete from MyUser where email=:usersEmail"
				);
		query.setParameter("usersEmail", myUser.getEmail());
		
		query.executeUpdate();

	}

}
