package com.snplog.backend.dto;

import java.sql.Timestamp;

/**
 * 
 * ChangeDTO class is a Data Transfer Object class.
 * This class models the data that is to be transfered to end users
 * Based upon the {@link.com.snplog.backend.entity.Change} entity class.
 * 
 * @author Theodor Urtegård
 *
 */
public class ChangeDTO {

	private int id;
	
	private MyUserDTO changedBy;
	
	private Timestamp created;
	
	private String tableName;
	
	private String columnName;
	
	private int rowNumber;
	
	private String oldValue;
	
	private String newValue;
	
	public ChangeDTO() {}

	/**
	 * 
	 * @param id
	 * @param changedBy
	 * @param created
	 * @param tableName
	 * @param columnName
	 * @param rowNumber
	 * @param oldValue
	 * @param newValue
	 */
	public ChangeDTO(int id, MyUserDTO changedBy, Timestamp created, String tableName, String columnName, int rowNumber,
			String oldValue, String newValue) {
		super();
		this.id = id;
		this.changedBy = changedBy;
		this.created = created;
		this.tableName = tableName;
		this.columnName = columnName;
		this.rowNumber = rowNumber;
		this.oldValue = oldValue;
		this.newValue = newValue;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public MyUserDTO getChangedBy() {
		return changedBy;
	}

	public void setChangedBy(MyUserDTO changedBy) {
		this.changedBy = changedBy;
	}

	public Timestamp getCreated() {
		return created;
	}

	public void setCreated(Timestamp created) {
		this.created = created;
	}

	public String getTableName() {
		return tableName;
	}

	public void setTableName(String tableName) {
		this.tableName = tableName;
	}

	public String getColumnName() {
		return columnName;
	}

	public void setColumnName(String columnName) {
		this.columnName = columnName;
	}

	public int getRowNumber() {
		return rowNumber;
	}

	public void setRowNumber(int rowNumber) {
		this.rowNumber = rowNumber;
	}

	public String getOldValue() {
		return oldValue;
	}

	public void setOldValue(String oldValue) {
		this.oldValue = oldValue;
	}

	public String getNewValue() {
		return newValue;
	}

	public void setNewValue(String newValue) {
		this.newValue = newValue;
	}

	@Override
	public String toString() {
		return "ChangeDTO [id=" + id + ", changedBy=" + changedBy + ", created=" + created + ", tableName=" + tableName
				+ ", columnName=" + columnName + ", rowNumber=" + rowNumber + ", oldValue=" + oldValue + ", newValue="
				+ newValue + "]";
	}
	
	
	
	
	
}
