package com.snplog.backend.dto;

import java.sql.Timestamp;

/**
 * 
 * PlowerPositionDTO class is a Data Transfer Object class.
 * This class models the data that is to be transfered to end users
 * Based upon the {@link.com.snplog.backend.entity.PlowerPosition} entity class.
 * 
 * @author Theodor Urtegård
 *
 */
public class PlowerPositionDTO {
	
	private int id;
	
	private MyUserDTO plower;
	
	private Timestamp datetime;
	
	private double latitude;
	
	private double longitude;
	
	public PlowerPositionDTO() {}

	/**
	 * 
	 * @param id
	 * @param plower
	 * @param datetime
	 * @param latitude
	 * @param longitude
	 */
	public PlowerPositionDTO(int id, MyUserDTO plower, Timestamp datetime, double latitude, double longitude) {
		super();
		this.id = id;
		this.plower = plower;
		this.datetime = datetime;
		this.latitude = latitude;
		this.longitude = longitude;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public MyUserDTO getPlower() {
		return plower;
	}

	public void setPlower(MyUserDTO plower) {
		this.plower = plower;
	}

	public Timestamp getDatetime() {
		return datetime;
	}

	public void setDatetime(Timestamp datetime) {
		this.datetime = datetime;
	}

	public double getLatitude() {
		return latitude;
	}

	public void setLatitude(double latitude) {
		this.latitude = latitude;
	}

	public double getLongitude() {
		return longitude;
	}

	public void setLongitude(double longitude) {
		this.longitude = longitude;
	}

	@Override
	public String toString() {
		return "PlowerPositionDTO [id=" + id + ", plower=" + plower + ", datetime=" + datetime + ", latitude="
				+ latitude + ", longitude=" + longitude + "]";
	}
	
	
	
	
	
}
