package com.snplog.backend.dto;

import java.sql.Timestamp;

/**
 * 
 * SnowStatisticDTO class is a Data Transfer Object class.
 * This class models the data that is to be transfered to end users
 * Based upon the {@link.com.snplog.backend.entity.SnowStatistic} entity class.
 * 
 * @author Theodor Urtegård
 *
 */
public class SnowStatisticDTO {

	private int id;
	
	private WeatherStationDTO weatherStation;
	
	private Timestamp created;
	
	private int sufaceSnowThickness;
	
	public SnowStatisticDTO() {}

	/**
	 * 
	 * @param id
	 * @param weatherStation
	 * @param created
	 * @param sufaceSnowThickness
	 */
	public SnowStatisticDTO(int id, WeatherStationDTO weatherStation, Timestamp created, int sufaceSnowThickness) {
		super();
		this.id = id;
		this.weatherStation = weatherStation;
		this.created = created;
		this.sufaceSnowThickness = sufaceSnowThickness;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public WeatherStationDTO getWeatherStation() {
		return weatherStation;
	}

	public void setWeatherStation(WeatherStationDTO weatherStation) {
		this.weatherStation = weatherStation;
	}

	public Timestamp getCreated() {
		return created;
	}

	public void setCreated(Timestamp created) {
		this.created = created;
	}

	public int getSufaceSnowThickness() {
		return sufaceSnowThickness;
	}

	public void setSufaceSnowThickness(int sufaceSnowThickness) {
		this.sufaceSnowThickness = sufaceSnowThickness;
	}

	@Override
	public String toString() {
		return "SnowStatisticDTO [id=" + id + ", weatherStation=" + weatherStation + ", created=" + created
				+ ", sufaceSnowThickness=" + sufaceSnowThickness + "]";
	}
	
	
	
}
