package com.snplog.backend.entity;

import java.sql.Timestamp;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;

@Entity
@Table(name="cabins")
public class Cabin {

	@Id
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	@Column(name="id")
	private int id = 0;
	
	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name="user_id")
	private MyUser cabinOwner;
	
	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name="cabin_area_id")
	private CabinArea cabinArea;
	
	@Column(name="cabin_name")
	private String cabinName;
	
	@Column(name="longitude")
	private double longitude;
	
	@Column(name="latitude")
	private double latitude;
	
	@Column(name="country")
	private String country;
	
	@Column(name="region")
	private String region;
	
	@Column(name="municipality")
	private String municipality;
	
	@Column(name="street_adress")
	private String streetAdress;
	
	@Column(name="kid")
	private int kid;
	
	@Column(name="gid")
	private int gid;
	
	@Column(name="bid")
	private int bid;
	
	@Column(name="cabin_status")
	private String cabinStatus; 
	
	@Column(name="last_plowed")
	private Timestamp lastPlowed;
	
	@Column(name="created")
	private Timestamp created;
	
	@OneToMany(
			mappedBy = "cabin",
			cascade = {CascadeType.ALL},
			fetch = FetchType.LAZY
			)
	private List<PlowingRequest> plowingRequests;
	
	public Cabin() {}

	

	public Cabin(int id, MyUser cabinOwner, CabinArea cabinArea, String cabinName, double longitude, double latitude,
			String country, String region, String municipality, String streetAdress, int kid, int gid, int bid,
			String cabinStatus, Timestamp created) {
		super();
		this.id = id;
		this.cabinOwner = cabinOwner;
		this.cabinArea = cabinArea;
		this.cabinName = cabinName;
		this.longitude = longitude;
		this.latitude = latitude;
		this.country = country;
		this.region = region;
		this.municipality = municipality;
		this.streetAdress = streetAdress;
		this.kid = kid;
		this.gid = gid;
		this.bid = bid;
		this.cabinStatus = cabinStatus;
		this.created = created;
	}



	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public MyUser getCabinOwner() {
		return cabinOwner;
	}

	public void setCabinOwner(MyUser cabinOwner) {
		this.cabinOwner = cabinOwner;
	}

	public CabinArea getCabinArea() {
		return cabinArea;
	}

	public void setCabinArea(CabinArea cabinArea) {
		this.cabinArea = cabinArea;
	}
	
	
	public String getCabinName() {
		return cabinName;
	}


	public void setCabinName(String cabinName) {
		this.cabinName = cabinName;
	}


	public double getLongitude() {
		return longitude;
	}

	public void setLongitude(double longitude) {
		this.longitude = longitude;
	}

	public double getLatitude() {
		return latitude;
	}

	public void setLatitude(double latitude) {
		this.latitude = latitude;
	}
	
	

	public String getCountry() {
		return country;
	}



	public void setCountry(String country) {
		this.country = country;
	}



	public String getRegion() {
		return region;
	}



	public void setRegion(String region) {
		this.region = region;
	}



	public String getMunicipality() {
		return municipality;
	}



	public void setMunicipality(String municipality) {
		this.municipality = municipality;
	}



	public String getStreetAdress() {
		return streetAdress;
	}



	public void setStreetAdress(String streetAdress) {
		this.streetAdress = streetAdress;
	}



	public int getKid() {
		return kid;
	}

	public void setKid(int kid) {
		this.kid = kid;
	}

	public int getGid() {
		return gid;
	}

	public void setGid(int gid) {
		this.gid = gid;
	}

	public int getBid() {
		return bid;
	}

	public void setBid(int bid) {
		this.bid = bid;
	}

	public String getCabinStatus() {
		return cabinStatus;
	}

	public void setCabinStatus(String cabinStatus) {
		this.cabinStatus = cabinStatus;
	}

	public Timestamp getLastPlowed() {
		return lastPlowed;
	}

	public void setLastPlowed(Timestamp lastPlowed) {
		this.lastPlowed = lastPlowed;
	}

	public List<PlowingRequest> getPlowingRequests() {
		return plowingRequests;
	}

	public void setPlowingRequests(List<PlowingRequest> plowingRequests) {
		this.plowingRequests = plowingRequests;
	}

	public Timestamp getCreated() {
		return created;
	}

	public void setCreated(Timestamp created) {
		this.created = created;
	}



	@Override
	public String toString() {
		return "Cabin [id=" + id + ", cabinOwner=" + cabinOwner + ", cabinArea=" + cabinArea + ", cabinName="
				+ cabinName + ", longitude=" + longitude + ", latitude=" + latitude + ", country=" + country
				+ ", region=" + region + ", municipality=" + municipality + ", streetAdress=" + streetAdress + ", kid="
				+ kid + ", gid=" + gid + ", bid=" + bid + ", cabinStatus=" + cabinStatus + ", lastPlowed=" + lastPlowed
				+ ", created=" + created + "]";
	}

	

	
}
