package com.snplog.backend.entity;

import java.sql.Timestamp;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

@Entity
@Table(name="changes")
public class Change {

	@Id
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	@Column(name="id")
	private int id;
	
	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name="changed_by")
	private MyUser changedBy;
	
	@Column(name="created")
	private Timestamp created;
	
	@Column(name="table_name_")
	private String tableName;
	
	@Column(name="column_name_")
	private String columnName;
	
	@Column(name="row_id")
	private int rowNumber;
	
	@Column(name="old_value")
	private String oldValue;
	
	@Column(name="new_value")
	private String newValue;

	public Change() {
	}

	public Change(MyUser changedBy, Timestamp created, String tableName, String columnName, int rowNumber,
			String oldValue, String newValue) {
		super();
		this.changedBy = changedBy;
		this.created = created;
		this.tableName = tableName;
		this.columnName = columnName;
		this.rowNumber = rowNumber;
		this.oldValue = oldValue;
		this.newValue = newValue;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public MyUser getChangedBy() {
		return changedBy;
	}

	public void setChangedBy(MyUser changedBy) {
		this.changedBy = changedBy;
	}

	public Timestamp getCreated() {
		return created;
	}

	public void setCreated(Timestamp created) {
		this.created = created;
	}

	public String getTableName() {
		return tableName;
	}

	public void setTableName(String tableName) {
		this.tableName = tableName;
	}

	public String getColumnName() {
		return columnName;
	}

	public void setColumnName(String columnName) {
		this.columnName = columnName;
	}

	public int getRowNumber() {
		return rowNumber;
	}

	public void setRowNumber(int rowNumber) {
		this.rowNumber = rowNumber;
	}

	public String getOldValue() {
		return oldValue;
	}

	public void setOldValue(String oldValue) {
		this.oldValue = oldValue;
	}

	public String getNewValue() {
		return newValue;
	}

	public void setNewValue(String newValue) {
		this.newValue = newValue;
	}

	@Override
	public String toString() {
		return "Change [id=" + id + ", changedBy=" + changedBy + ", created=" + created + ", tableName=" + tableName
				+ ", columnName=" + columnName + ", rowNumber=" + rowNumber + ", oldValue=" + oldValue + ", newValue="
				+ newValue + "]";
	}

	
	
	
	
	
	
	
}
