package com.snplog.backend.entity;

import java.sql.Timestamp;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

@Entity
@Table(name="messages")
public class Message {
	
	@Id
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	@Column(name="id")
	private int id;
	
	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name="sender_id")
	private MyUser sender;
	
	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name="thread_id")
	private MessageThread messageThread;;
	
	@Column(name="message")
	private String messageContent;
	
	@Column(name="date_created")
	private Timestamp dateCreated;
	
	public Message() {}

	public Message(MyUser sender, MessageThread messageThread, String messageContent, Timestamp dateCreated) {
		super();
		this.sender = sender;
		this.messageThread = messageThread;
		this.messageContent = messageContent;
		this.dateCreated = dateCreated;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public MyUser getSender() {
		return sender;
	}

	public void setSender(MyUser sender) {
		this.sender = sender;
	}

	public MessageThread getMessageThread() {
		return messageThread;
	}

	public void setMessageThread(MessageThread messageThread) {
		this.messageThread = messageThread;
	}

	public String getMessageContent() {
		return messageContent;
	}

	public void setMessageContent(String messageContent) {
		this.messageContent = messageContent;
	}

	public Timestamp getDateCreated() {
		return dateCreated;
	}

	public void setDateCreated(Timestamp dateCreated) {
		this.dateCreated = dateCreated;
	}

	@Override
	public String toString() {
		return "Message [id=" + id + ", sender=" + sender + ", messageThread=" + messageThread + ", messageContent=" + messageContent
				+ ", dateCreated=" + dateCreated + "]";
	}
	
	

}
