package com.snplog.backend.entity;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.OneToMany;
import javax.persistence.Table;

@Entity
@Table(name="message_threads")
public class MessageThread {

	@Id
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	@Column(name="id")
	private int id;
	
	@Column(name="date_created")
	private Timestamp dateCreated;
	
	@Column(name="closed")
	private boolean closed;
	
	@Column(name="date_closed")
	private Timestamp dateClosed;
	
	@OneToMany(
			mappedBy = "messageThread",
			cascade = CascadeType.ALL,
			orphanRemoval = true,
			fetch = FetchType.LAZY
			)
	private List<Message> messages = new ArrayList<>();
	
	@JoinTable(
			name="user_threads",
			joinColumns = @JoinColumn(
					name="user_id",
					referencedColumnName="id"
					),
			inverseJoinColumns = @JoinColumn(
					name="thread_id",
					referencedColumnName="id"
					)
			)
	@OneToMany
	private List<MyUser> myUsers = new ArrayList<>();
	
	public MessageThread() {}

	public MessageThread(Timestamp dateCreated, boolean closed, Timestamp dateClosed) {
		super();
		this.dateCreated = dateCreated;
		this.closed = closed;
		this.dateClosed = dateClosed;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public Timestamp getDateCreated() {
		return dateCreated;
	}

	public void setDateCreated(Timestamp dateCreated) {
		this.dateCreated = dateCreated;
	}

	public boolean isClosed() {
		return closed;
	}

	public void setClosed(boolean closed) {
		this.closed = closed;
	}

	public Timestamp getDateClosed() {
		return dateClosed;
	}

	public void setDateClosed(Timestamp dateClosed) {
		this.dateClosed = dateClosed;
	}


	public List<Message> getMessages() {
		return messages;
	}

	public void setMessages(List<Message> messages) {
		this.messages = messages;
	}
	
	

	public List<MyUser> getMyUsers() {
		return myUsers;
	}

	public void setMyUsers(List<MyUser> myUsers) {
		this.myUsers = myUsers;
	}

	@Override
	public String toString() {
		return "MessageThread [id=" + id + ", dateCreated=" + dateCreated + ", closed=" + closed
				+ ", dateClosed=" + dateClosed + ", messages=" + messages + "]";
	}
	
	
	
}
