package com.snplog.backend.entity;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToMany;
import javax.persistence.OneToMany;
import javax.persistence.Table;

@Entity
@Table(name="users")
public class MyUser {
	
	// TODO look at the cascade types needed
	// TODO look at the add methods for lists

	@Id
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	@Column(name="id")
	private int id;
	
	@Column(name="first_name")
	private String firstName;
	
	@Column(name="last_name")
	private String lastName;
	
	@Column(name="email")
	private String email;
	
	@Column(name="otp")
	private String otp;
	
	@Column(name="phone_number")
	private String phoneNumber;
	
	@Column(name="street_adress")
	private String streetAdress;
	
	@Column(name="city")
	private String city;

	@Column(name="country")
	private String country;
	
	@Column(name="time_created")
	private Timestamp dateTimeCreated;
	
	@OneToMany(mappedBy="myUser")
	private List<MyUserRole> myUserRoles = new ArrayList<>();
	
	
	@OneToMany(
			mappedBy = "plower",
			cascade = CascadeType.ALL,
			orphanRemoval = true,
			fetch = FetchType.LAZY
			)
	private List<PlowerPosition> plowerPositions = new ArrayList<>();
	
	@OneToMany(
			mappedBy = "plower",
			cascade = CascadeType.ALL,
			orphanRemoval = true,
			fetch = FetchType.LAZY
			)
	private List<PlowerRequest> plowerRequests = new ArrayList<>();
	
	
	@OneToMany(
			mappedBy = "cabinOwner",
			cascade = CascadeType.ALL,
			orphanRemoval = true,
			fetch = FetchType.LAZY
			)
	private List<Cabin> cabins = new ArrayList<>();
	
	@OneToMany(
			mappedBy = "plower",
			cascade = CascadeType.ALL,
			orphanRemoval = true,
			fetch = FetchType.LAZY
			)
	private List<PlowerCabinArea> plowerCabinAreas = new ArrayList<>();
	
	@OneToMany(
			mappedBy = "changedBy",
			cascade = CascadeType.ALL,
			orphanRemoval = true,
			fetch = FetchType.LAZY
			)
	private List<Change> changes = new ArrayList<>();
	
	@OneToMany(
			mappedBy = "sender",
			cascade = CascadeType.ALL,
			orphanRemoval = true,
			fetch = FetchType.LAZY
			)
	private List<Message> messages = new ArrayList<>();
	
	public MyUser() {}

	

	



	public MyUser(int id, String firstName, String lastName, String email, String otp, String phoneNumber,
			String streetAdress, String city, String country, Timestamp dateTimeCreated, List<MyUserRole> myUserRoles) {
		super();
		this.id = id;
		this.firstName = firstName;
		this.lastName = lastName;
		this.email = email;
		this.otp = otp;
		this.phoneNumber = phoneNumber;
		this.streetAdress = streetAdress;
		this.city = city;
		this.country = country;
		this.dateTimeCreated = dateTimeCreated;
		this.myUserRoles = myUserRoles;
	}







	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getFirstName() {
		return firstName;
	}

	public void setFirstName(String firstName) {
		this.firstName = firstName;
	}

	public String getLastName() {
		return lastName;
	}

	public void setLastName(String lastName) {
		this.lastName = lastName;
	}

	public String getEmail() {
		return email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	public String getOtp() {
		return otp;
	}

	public void setOtp(String otp) {
		this.otp = otp;
	}

	public String getPhoneNumber() {
		return phoneNumber;
	}

	public void setPhoneNumber(String phoneNumber) {
		this.phoneNumber = phoneNumber;
	}

	public String getStreetAdress() {
		return streetAdress;
	}

	public void setStreetAdress(String streetAdress) {
		this.streetAdress = streetAdress;
	}

	public String getCity() {
		return city;
	}

	public void setCity(String city) {
		this.city = city;
	}

	public String getCountry() {
		return country;
	}

	public void setCountry(String country) {
		this.country = country;
	}

	public Timestamp getDateTimeCreated() {
		return dateTimeCreated;
	}

	public void setDateTimeCreated(Timestamp dateTimeCreated) {
		this.dateTimeCreated = dateTimeCreated;
	}

	

	



	public List<MyUserRole> getMyUserRoles() {
		return myUserRoles;
	}



	public void setMyUserRoles(List<MyUserRole> myUserRoles) {
		this.myUserRoles = myUserRoles;
	}



	public List<PlowerPosition> getPlowerPositions() {
		return plowerPositions;
	}

	public void setPlowerPositions(List<PlowerPosition> plowerPositions) {
		this.plowerPositions = plowerPositions;
	}

	public List<PlowerRequest> getPlowerPlowerRequests() {
		return plowerRequests;
	}

	public void setPlowerPlowerRequests(List<PlowerRequest> plowerPlowerRequests) {
		this.plowerRequests = plowerPlowerRequests;
	}


	public List<Cabin> getCabins() {
		return cabins;
	}

	public void setCabins(List<Cabin> cabins) {
		this.cabins = cabins;
	}

	

	public List<PlowerCabinArea> getPlowerCabinAreas() {
		return plowerCabinAreas;
	}

	public void setPlowerCabinAreas(List<PlowerCabinArea> plowerCabinAreas) {
		this.plowerCabinAreas = plowerCabinAreas;
	}

	public List<Change> getChanges() {
		return changes;
	}

	public void setChanges(List<Change> changes) {
		this.changes = changes;
	}



	public List<PlowerRequest> getPlowerRequests() {
		return plowerRequests;
	}



	public void setPlowerRequests(List<PlowerRequest> plowerRequests) {
		this.plowerRequests = plowerRequests;
	}


	public List<Message> getMessages() {
		return messages;
	}



	public void setMessages(List<Message> messages) {
		this.messages = messages;
	}



	@Override
	public String toString() {
		return "MyUser [id=" + id + ", firstName=" + firstName + ", lastName=" + lastName + ", email=" + email
				+ ", otp=" + otp + ", phoneNumber=" + phoneNumber + ", streetAdress=" + streetAdress + ", city=" + city
				+ ", country=" + country + ", dateTimeCreated=" + dateTimeCreated + ", myUserRoles=" + myUserRoles + "]";
	}
	
	
	
	
}
