package com.snplog.backend.entity;

import java.util.List;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

@Entity
@Table(name="user_roles")
public class MyUserRole {

	@Id
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	@Column(name="id")
	private int id;
	
	@ManyToOne
	@JoinColumn(name="role")
	private Role role;
	
	@ManyToOne
	@JoinColumn(name="user_id")
	private MyUser myUser;
	
	public MyUserRole() {}

	public MyUserRole(int id, Role role, MyUser myUser) {
		super();
		this.id = id;
		this.role = role;
		this.myUser = myUser;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public Role getRole() {
		return role;
	}

	public void setRole(Role role) {
		this.role = role;
	}

	public MyUser getMyUser() {
		return myUser;
	}

	public void setMyUser(MyUser myUser) {
		this.myUser = myUser;
	}

	@Override
	public String toString() {
		return "MyUserRole [id=" + id + ", role=" + role + ", myUser=" + myUser + "]";
	}
	
	
	
}
