package com.snplog.backend.entity;

import java.sql.Timestamp;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

@Entity
@Table(name="plower_cabin_area")
public class PlowerCabinArea {
	
	@Id
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	@Column(name="id")
	private int id;
	
	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name="plower_id")
	private MyUser plower;
	
	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name="cabin_area_id")
	private CabinArea cabinArea;
	
	@Column(name="valid")
	private Boolean valid;
	
	@Column(name="date_created")
	private Timestamp dateCreated;
	
	@Column(name="date_ended")
	private Timestamp dateEnded;

	public PlowerCabinArea() {

	}

	public PlowerCabinArea(MyUser plower, CabinArea cabinArea, Boolean valid, Timestamp dateCreated) {
		super();
		this.plower = plower;
		this.cabinArea = cabinArea;
		this.valid = valid;
		this.dateCreated = dateCreated;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public MyUser getPlower() {
		return plower;
	}

	public void setPlower(MyUser plower) {
		this.plower = plower;
	}

	public CabinArea getCabinArea() {
		return cabinArea;
	}

	public void setCabinArea(CabinArea cabinArea) {
		this.cabinArea = cabinArea;
	}

	public Boolean getValid() {
		return valid;
	}

	public void setValid(Boolean valid) {
		this.valid = valid;
	}

	public Timestamp getDateCreated() {
		return dateCreated;
	}

	public void setDateCreated(Timestamp dateCreated) {
		this.dateCreated = dateCreated;
	}

	public Timestamp getDateEnded() {
		return dateEnded;
	}

	public void setDateEnded(Timestamp dateEnded) {
		this.dateEnded = dateEnded;
	}

	@Override
	public String toString() {
		return "PlowerCabinArea [id=" + id + ", plower=" + plower + ", cabinArea=" + cabinArea + ", valid=" + valid
				+ ", dateCreated=" + dateCreated + ", dateEnded=" + dateEnded + "]";
	}
	
	
	
}
