package com.snplog.backend.entity;

import java.sql.Timestamp;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

@Entity
@Table(name="plower_positions")
public class PlowerPosition {


	@Id
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	@Column(name="id")
	private int id;
	
	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name="plower_id")
	private MyUser plower;
	
	@Column(name="timestamp_")
	private Timestamp dateTime;
	
	@Column(name="longitude")
	private double longitude;
	
	@Column(name="latitude")
	private double latitude;
	
	public PlowerPosition() {}

	public PlowerPosition(MyUser plower, Timestamp dateTime, double longitude, double latitude) {
		super();
		this.plower = plower;
		this.dateTime = dateTime;
		this.longitude = longitude;
		this.latitude = latitude;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public MyUser getPlower() {
		return plower;
	}

	public void setPlower(MyUser plower) {
		this.plower = plower;
	}

	public Timestamp getDateTime() {
		return dateTime;
	}

	public void setDateTime(Timestamp dateTime) {
		this.dateTime = dateTime;
	}

	public double getLongitude() {
		return longitude;
	}

	public void setLongitude(double longitude) {
		this.longitude = longitude;
	}

	public double getLatitude() {
		return latitude;
	}

	public void setLatitude(double latitude) {
		this.latitude = latitude;
	}

	@Override
	public String toString() {
		return "PlowerPosition [id=" + id + ", plower=" + plower + ", dateTime=" + dateTime + ", longitude=" + longitude
				+ ", latitude=" + latitude + "]";
	}

	
	
	
	
}
