package com.snplog.backend.entity;

import java.sql.Timestamp;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

@Entity
@Table(name="plower_requests")
public class PlowerRequest {

	@Id
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	@Column(name="id")
	private int id;
	
	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name="user_id")
	private MyUser plower;
	
	@Column(name="date_requested")
	private Timestamp dateRequested;
	
	@Column(name="date_responded")
	private Timestamp dateResponded;
	
	@Column(name="request_status")
	private boolean status;
	
	public PlowerRequest() {}

	public PlowerRequest(MyUser plower, Timestamp dateRequested, Timestamp dateResponded, boolean status) {
		super();
		this.plower = plower;
		this.dateRequested = dateRequested;
		this.dateResponded = dateResponded;
		this.status = status;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public MyUser getPlower() {
		return plower;
	}

	public void setPlower(MyUser plower) {
		this.plower = plower;
	}

	public Timestamp getDateRequested() {
		return dateRequested;
	}

	public void setDateRequested(Timestamp dateRequested) {
		this.dateRequested = dateRequested;
	}

	public Timestamp getDateResponded() {
		return dateResponded;
	}

	public void setDateResponded(Timestamp dateResponded) {
		this.dateResponded = dateResponded;
	}

	public boolean isStatus() {
		return status;
	}

	public void setStatus(boolean status) {
		this.status = status;
	}

	@Override
	public String toString() {
		return "PlowerRequest [id=" + id + ", plower=" + plower + ", dateRequested=" + dateRequested
				+ ", dateResponded=" + dateResponded + ", status=" + status + "]";
	}

	
	
	
}
