package com.snplog.backend.entity;

import java.sql.Timestamp;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

@Entity
@Table(name="plowing_requests")
public class PlowingRequest {

	@Id
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	@Column(name="id")
	private int id;
	
	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name="cabin_id")
	private Cabin cabin;
	
	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name="cabin_area_id")
	private CabinArea cabinArea;
	
	@Column(name="date_of_arrival")
	private Timestamp dateOfArrival;
	
	@Column(name="date_of_departure")
	private Timestamp dateOfDeparture;
	
	@Column(name="date_requested")
	private Timestamp dateRequested;
	
	@Column(name="date_completed")
	private Timestamp dateCompleted;
	
	@Column(name="completed")
	private boolean completed;
	
	@Column(name="description_")
	private String description;
	
	public PlowingRequest() {}

	public PlowingRequest(Cabin cabin, CabinArea cabinArea, Timestamp dateOfArrival, Timestamp dateOfDeparture, Timestamp dateRequested, boolean completed,
			String description) {
		super();
		this.cabin = cabin;
		this.cabinArea = cabinArea;
		this.dateOfArrival = dateOfArrival;
		this.dateOfDeparture = dateOfDeparture;
		this.dateRequested = dateRequested;
		this.completed = completed;
		this.description = description;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public Cabin getCabin() {
		return cabin;
	}

	public void setCabin(Cabin cabin) {
		this.cabin = cabin;
	}

	public CabinArea getCabinArea() {
		return cabinArea;
	}

	public void setCabinArea(CabinArea cabinArea) {
		this.cabinArea = cabinArea;
	}

	public Timestamp getDateRequested() {
		return dateRequested;
	}

	public void setDateRequested(Timestamp dateRequested) {
		this.dateRequested = dateRequested;
	}

	public Timestamp getDateCompleted() {
		return dateCompleted;
	}

	public void setDateCompleted(Timestamp dateCompleted) {
		this.dateCompleted = dateCompleted;
	}

	public boolean isCompleted() {
		return completed;
	}

	public void setCompleted(boolean completed) {
		this.completed = completed;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}
	
	

	public Timestamp getDateOfArrival() {
		return dateOfArrival;
	}

	public void setDateOfArrival(Timestamp dateOfArrival) {
		this.dateOfArrival = dateOfArrival;
	}

	public Timestamp getDateOfDeparture() {
		return dateOfDeparture;
	}

	public void setDateOfDeparture(Timestamp dateOfDeparture) {
		this.dateOfDeparture = dateOfDeparture;
	}

	@Override
	public String toString() {
		return "PlowingRequest [id=" + id + ", cabin=" + cabin + ", cabinArea=" + cabinArea + ", dateOfArrival="
				+ dateOfArrival + ", dateOfDeparture=" + dateOfDeparture + ", dateRequested=" + dateRequested
				+ ", dateCompleted=" + dateCompleted + ", completed=" + completed + ", description=" + description
				+ "]";
	}

	
	
	
	
	
}
