package com.snplog.backend.entity;

import java.util.List;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.ManyToMany;
import javax.persistence.OneToMany;
import javax.persistence.Table;

import com.fasterxml.jackson.annotation.JsonIgnore;

@Entity
@Table(name="roles")
public class Role {

	@Id
	@Column(name="role")
	private String role;
	
	@Column(name="description")
	private String description;
	
	@JsonIgnore
	@OneToMany(mappedBy="role")
	List<MyUserRole> myUserRoles;
	
	public Role() {}


	public Role(String role, String description, List<MyUserRole> myUserRoles) {
		super();
		this.role = role;
		this.description = description;
		this.myUserRoles = myUserRoles;
	}


	public String getRole() {
		return role;
	}


	public void setRole(String role) {
		this.role = role;
	}


	public String getDescription() {
		return description;
	}


	public void setDescription(String description) {
		this.description = description;
	}


	public List<MyUserRole> getMyUserRoles() {
		return myUserRoles;
	}


	public void setMyUserRoles(List<MyUserRole> myUserRoles) {
		this.myUserRoles = myUserRoles;
	}


	@Override
	public String toString() {
		return "Role [role=" + role + ", description=" + description + ", myUserRoles=" + myUserRoles + "]";
	}

	
	
	
}
