package com.snplog.backend.entity;

import java.sql.Timestamp;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

@Entity
@Table(name="snow_statistics")
public class SnowStatistic {
	
	@Id
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	@Column(name="id")
	private int id;
	
	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name="weather_station_id")
	private WeatherStation weatherStation;
	
	@Column(name="created")
	private Timestamp created;
	
	@Column(name="surface_snow_thickness")
	private int surfaceSnowThickness;

	public SnowStatistic() {}

	public SnowStatistic(int id, WeatherStation weatherStation, Timestamp created, int surfaceSnowThickness) {
		super();
		this.id = id;
		this.weatherStation = weatherStation;
		this.created = created;
		this.surfaceSnowThickness = surfaceSnowThickness;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public WeatherStation getWeatherStation() {
		return weatherStation;
	}

	public void setWeatherStation(WeatherStation weatherStation) {
		this.weatherStation = weatherStation;
	}

	public Timestamp getCreated() {
		return created;
	}

	public void setCreated(Timestamp created) {
		this.created = created;
	}

	public int getSurfaceSnowThickness() {
		return surfaceSnowThickness;
	}

	public void setSurfaceSnowThickness(int surfaceSnowThickness) {
		this.surfaceSnowThickness = surfaceSnowThickness;
	}

	@Override
	public String toString() {
		return "SnowStatistic [id=" + id + ", weatherStation=" + weatherStation + ", created=" + created
				+ ", surfaceSnowThickness=" + surfaceSnowThickness + "]";
	}
	
	
	
	

}
