package com.snplog.backend.entity;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.OneToMany;
import javax.persistence.Table;

@Entity
@Table(name="weather_stations")
public class WeatherStation {

	@Id
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	@Column(name="id")
	private int id;
	
	@Column(name="created")
	private Timestamp created;
	
	@Column(name="frost_id")
	private String frostId;
	
	@Column(name="longitude")
	private double longitude;
	
	@Column(name="latitude")
	private double latitude;
	
	@OneToMany(
			mappedBy = "nearestWeatherStation",
			cascade = CascadeType.ALL,
			orphanRemoval = true,
			fetch = FetchType.LAZY
			)
	private List<CabinArea> cabinAreas = new ArrayList<>();
	
	@OneToMany(
			mappedBy = "weatherStation",
			cascade = CascadeType.ALL,
			orphanRemoval = true,
			fetch = FetchType.LAZY
			)
	private List<SnowStatistic> snowStatistics = new ArrayList<>();

	public WeatherStation() {}

	public WeatherStation(int id, Timestamp created, String frostId, double longitude, double latitude) {
		super();
		this.id = id;
		this.created = created;
		this.frostId = frostId;
		this.longitude = longitude;
		this.latitude = latitude;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public Timestamp getCreated() {
		return created;
	}

	public void setCreated(Timestamp created) {
		this.created = created;
	}

	public String getFrostId() {
		return frostId;
	}

	public void setFrostId(String frostId) {
		this.frostId = frostId;
	}

	public double getLongitude() {
		return longitude;
	}

	public void setLongitude(double longitude) {
		this.longitude = longitude;
	}

	public double getLatitude() {
		return latitude;
	}

	public void setLatitude(double latitude) {
		this.latitude = latitude;
	}

	public List<CabinArea> getCabinAreas() {
		return cabinAreas;
	}

	public void setCabinAreas(List<CabinArea> cabinAreas) {
		this.cabinAreas = cabinAreas;
	}

	public List<SnowStatistic> getSnowStatistics() {
		return snowStatistics;
	}

	public void setSnowStatistics(List<SnowStatistic> snowStatistics) {
		this.snowStatistics = snowStatistics;
	}

	@Override
	public String toString() {
		return "WeatherStation [id=" + id + ", created=" + created + ", frostId=" + frostId + ", longitude=" + longitude
				+ ", latitude=" + latitude + "]";
	}

	
	
	
	
}
