package com.snplog.backend.models;

/**
 * 
 * @author Theodor Urtegård
 * 
 * A sorted query request model.
 * Makes queries for database entries very flexible for the client application
 *
 */
public class SortedQueryRequest {

	private String column;
	
	private String order;
	
	private int offset;
	
	private int rowCount;
	
	public SortedQueryRequest() {}

	public SortedQueryRequest(String column, String order, int offset, int rowCount) {
		super();
		this.column = column;
		this.order = order;
		this.offset = offset;
		this.rowCount = rowCount;
	}

	public String getColumn() {
		return column;
	}

	public void setColumn(String column) {
		this.column = column;
	}

	public String getOrder() {
		return order;
	}

	public void setOrder(String order) {
		this.order = order;
	}

	public int getOffset() {
		return offset;
	}

	public void setOffset(int offset) {
		this.offset = offset;
	}

	public int getRowCount() {
		return rowCount;
	}

	public void setRowCount(int rowCount) {
		this.rowCount = rowCount;
	}

	@Override
	public String toString() {
		return "SortedQueryRequest [column=" + column + ", order=" + order + ", offset=" + offset + ", rowCount="
				+ rowCount + "]";
	}
	
	
	
}
