package com.snplog.backend.repository;

import java.util.List;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.PagingAndSortingRepository;
import org.springframework.data.repository.query.Param;

import com.snplog.backend.entity.MyUser;

public interface MyUserRepository extends JpaRepository<MyUser, Integer>, PagingAndSortingRepository<MyUser, Integer>, CrudRepository<MyUser, Integer> {
	
	@Query("SELECT u FROM MyUser u WHERE u.email = :email")
	public MyUser getMyUserByEmail(@Param("email") String email);

	public List<MyUser> findByFirstNameIgnoreCaseOrderByFirstName(String firstName);
	
	public List<MyUser> findByFirstName(String firstName);
}
