package com.snplog.backend.repository;

import java.sql.Timestamp;
import java.util.List;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;
import org.springframework.data.repository.query.Param;

import com.snplog.backend.entity.CabinArea;
import com.snplog.backend.entity.PlowingRequest;

public interface PlowingRequestRepository extends JpaRepository<PlowingRequest, Integer>, PagingAndSortingRepository<PlowingRequest, Integer> {

	@Query("SELECT p FROM PlowingRequest p WHERE completed = false AND cabinArea = :cabinArea AND (dateOfArrival < :dateOfArrival OR dateOfDeparture < :dateOfDeparture)")
	public List<PlowingRequest> findPlowingRequestByCabinAreaIdAndDateOfArrival(@Param("cabinArea") CabinArea cabinArea,@Param("dateOfArrival") Timestamp dateOfArrival, @Param("dateOfDeparture") Timestamp dateOfDeparture);
	
	@Query("SELECT p FROM PlowingRequest p WHERE cabin.id = :cabinId AND p.completed = false")
	public List<PlowingRequest> findPlowingRequestByCabinId(@Param("cabinId") int id);
	
	@Query("SELECT p FROM PlowingRequest p WHERE cabinArea.id = :cabinAreaId")
	public List<PlowingRequest> findPlowingRequestByCabinAreaId(@Param("cabinAreaId") int id);
	
}
