package com.snplog.backend.rest;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.google.maps.model.DirectionsResult;
import com.snplog.backend.models.PlowerRouteRequest;
import com.snplog.backend.services.misc.JwtUtil;
import com.snplog.backend.services.misc.OptimalRouteService;

@RestController
@RequestMapping("/route")
public class RouteRestController {
	
	@Autowired
	private OptimalRouteService optimalRouteService;
	
	@Autowired
	private JwtUtil jwtUtil;
	
	@PostMapping("optimalroute")
	public ResponseEntity<?> getOptimalRoute(HttpServletRequest request, @RequestBody PlowerRouteRequest plowerRouteRequest){
		try {
			final String authorizationHeader = request.getHeader("Authorization");
			
			if(authorizationHeader != null && authorizationHeader.startsWith("Bearer" )) {
				
				String jwt = authorizationHeader.substring(7);
			
				if(jwtUtil.extractRoles(jwt).contains("plower") || jwtUtil.extractRoles(jwt).contains("admin")){
					
					DirectionsResult result = optimalRouteService.getDirectionsForQuickestRoute(plowerRouteRequest);
					
					return ResponseEntity.ok().header("Content-Type", "application/json; charset=utf-8").body(result);
				}
			}
			return ResponseEntity.badRequest().build();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			return ResponseEntity.badRequest().build();
		}
	}
	
	@PostMapping("optimalroutetest")
	public ResponseEntity<?> testOptimalRoute(HttpServletRequest request, @RequestBody PlowerRouteRequest plowerRouteRequest){
		
			
			System.out.println(plowerRouteRequest.toString());
		
					
					DirectionsResult result = optimalRouteService.getDirectionsForQuickestRoute(plowerRouteRequest);
					
					return ResponseEntity.ok().header("Content-Type", "application/json; charset=utf-8").body(result);
				
	
	}
	
	
}
