package com.snplog.backend.rest;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.snplog.backend.dto.PlowerRequestDTO;
import com.snplog.backend.dto.PlowingRequestDTO;
import com.snplog.backend.entity.Cabin;
import com.snplog.backend.entity.PlowerRequest;
import com.snplog.backend.entity.PlowingRequest;
import com.snplog.backend.repository.PlowerRequestRepository;
import com.snplog.backend.repository.PlowingRequestRepository;
import com.snplog.backend.services.CabinService;
import com.snplog.backend.services.RoleService;
import com.snplog.backend.services.misc.CabinPositionService;
import com.snplog.backend.services.misc.JpaDtoMapper;
import com.snplog.backend.singleton.DirectionsService;

@RestController
@RequestMapping("/test")
public class TestRest {
	
	@Autowired
	private CabinPositionService cabinPositionService;

	@Autowired
	private DirectionsService ds;
	
	@Autowired
	private RoleService rs;
	
	@Autowired
	private CabinService cabinService;
	
	@Autowired
	private PlowingRequestRepository prr;
	
	@Autowired
	private PlowerRequestRepository prrp;
	
	@Autowired
	private JpaDtoMapper jpaDtoMapper;
	
	@GetMapping("/roles")
	public ResponseEntity<?> getRoles(){
		return ResponseEntity.ok(rs.findAll());
	}
	
	@GetMapping("/kartverket")
	public void printKartverketResponse() {
		Cabin cabin = cabinService.getCabinById(1);
		try {
			cabin = cabinPositionService.getLongLatForCabin(cabin);
			cabinService.saveCabin(cabin);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	@GetMapping("/cabinplowrequest")
	public ResponseEntity<?> getPlowRequestByCabin(){
		List<PlowingRequest> rs = prr.findPlowingRequestByCabinId(1);
		List<PlowingRequestDTO> rsdto = new ArrayList<>();
		for(PlowingRequest pr : rs) {
			rsdto.add(jpaDtoMapper.toDTO(pr));
		}
		return ResponseEntity.ok(rsdto);
	}
	
	@GetMapping("/prquery")
	public ResponseEntity<?> getPlowerRequestsUncomplete(){
		List<PlowerRequest> result = prrp.getActivePlowerRequests();
		List<PlowerRequestDTO> rsdto = new ArrayList<>();
		for(PlowerRequest pr : result) {
			rsdto.add(jpaDtoMapper.toDTO(pr));
		}
		return ResponseEntity.ok(rsdto);
	}
	
	
}
