package com.snplog.backend.services;

import java.util.List;

import com.snplog.backend.dto.CabinDTO;
import com.snplog.backend.dto.MyUserDTO;
import com.snplog.backend.entity.Cabin;
import com.snplog.backend.models.SortedQueryRequest;


public interface CabinService {
	
	public List<CabinDTO> findAll();
	
	public CabinDTO getCabin(int id);
	
	public void saveCabin(Cabin cabin);
	
	public void updateCabin(CabinDTO cabinDTO);
	
	public void addLocation(Cabin cabin);

	public void deleteCabin(CabinDTO cabinDTO);

	public List<CabinDTO> getCabinsByMyUser(int id);

	public List<CabinDTO> getCabinsSortedBy(SortedQueryRequest sortedQueryRequest);

	public List<CabinDTO> getCabinsByCabinNameSortedByCabinName(String name);

	public void deleteCabinById(int id);

	public Cabin getCabinById(int id);
	
}
