package com.snplog.backend.services.implementations;

import java.util.List;
import java.util.Optional;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.snplog.backend.entity.Role;
import com.snplog.backend.repository.RoleRepository;
import com.snplog.backend.services.RoleService;

@Service
public class RoleServiceImpl implements RoleService {

	@Autowired
	private RoleRepository roleRepository;
	
	@Override
	public List<Role> findAll() {
		return roleRepository.findAll();
	}

	@Override
	public Role getRole(String id) {

		Optional<Role> result = roleRepository.findById(id);
		
		Role role = null;
		
		if(result.isPresent()) {
			role = result.get();
		} else {
			throw new RuntimeException("Did not find the Role id - " + id);
		}
		
		return role;
	}

	@Override
	public void saveRole(Role role) {
		roleRepository.save(role);
	}

	@Override
	public void deleteRole(Role role) {
		roleRepository.delete(role);
	}
	
	@Override
	public void deleteRoleById(String id) {
		roleRepository.deleteById(id);
	}

}
