package com.snplog.backend.services.misc;

import java.util.Optional;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.snplog.backend.adapter.CabinAdapter;
import com.snplog.backend.adapter.CabinAreaAdapter;
import com.snplog.backend.adapter.ChangeAdapter;
import com.snplog.backend.adapter.MessageAdapter;
import com.snplog.backend.adapter.MessageThreadAdapter;
import com.snplog.backend.adapter.MyUserAdapter;
import com.snplog.backend.adapter.PlowerCabinAreaAdapter;
import com.snplog.backend.adapter.PlowerPositionAdapter;
import com.snplog.backend.adapter.PlowerRequestAdapter;
import com.snplog.backend.adapter.PlowingRequestAdapter;
import com.snplog.backend.adapter.SnowStatisticAdapter;
import com.snplog.backend.adapter.WeatherStationAdapter;
import com.snplog.backend.dto.CabinAreaDTO;
import com.snplog.backend.dto.CabinDTO;
import com.snplog.backend.dto.ChangeDTO;
import com.snplog.backend.dto.MessageDTO;
import com.snplog.backend.dto.MessageThreadDTO;
import com.snplog.backend.dto.MyUserDTO;
import com.snplog.backend.dto.PlowerCabinAreaDTO;
import com.snplog.backend.dto.PlowerPositionDTO;
import com.snplog.backend.dto.PlowerRequestDTO;
import com.snplog.backend.dto.PlowingRequestDTO;
import com.snplog.backend.dto.SnowStatisticDTO;
import com.snplog.backend.dto.WeatherStationDTO;
import com.snplog.backend.entity.Cabin;
import com.snplog.backend.entity.CabinArea;
import com.snplog.backend.entity.Change;
import com.snplog.backend.entity.Message;
import com.snplog.backend.entity.MessageThread;
import com.snplog.backend.entity.MyUser;
import com.snplog.backend.entity.PlowerCabinArea;
import com.snplog.backend.entity.PlowerPosition;
import com.snplog.backend.entity.PlowerRequest;
import com.snplog.backend.entity.PlowingRequest;
import com.snplog.backend.entity.SnowStatistic;
import com.snplog.backend.entity.WeatherStation;

@Service
public class JpaDtoMapper {
	
	@Autowired
	private CabinAdapter cabinAdapter;
	
	@Autowired
	private CabinAreaAdapter cabinAreaAdapter;
	
	@Autowired
	private ChangeAdapter changeAdapter;
	
	@Autowired
	private MessageAdapter messageAdapter;
	
	@Autowired
	private MessageThreadAdapter messageThreadAdapter;
	
	@Autowired
	private MyUserAdapter myUserAdapter;

	@Autowired
	private PlowerCabinAreaAdapter plowerCabinAreaAdapter;
	
	@Autowired
	private PlowerPositionAdapter plowerPositionAdapter;
	
	@Autowired
	private PlowerRequestAdapter plowerRequestAdapter;
	
	@Autowired
	private PlowingRequestAdapter plowingRequestAdapter;
	
	@Autowired
	private SnowStatisticAdapter snowStatisticAdapter;
	
	@Autowired
	private WeatherStationAdapter weatherStationAdapter;
	
	public <T> T toDTO(Object object) {
		if(object instanceof Cabin) {
			try {
				CabinDTO cabinDTO = cabinAdapter.toDTO((Cabin) object);
				return (T) cabinDTO;
			} catch(Exception e) {
				System.out.println("Failed in JpaDtoMapping");
				e.printStackTrace();
			}
			return null;
		}
		
		if(object instanceof CabinArea) {
			try {
				CabinAreaDTO cabinAreaDTOFinal = cabinAreaAdapter.toDTOFinal((CabinArea) object);
				return (T) cabinAreaDTOFinal;
			} catch(Exception e) {
				System.out.println("Failed in JpaDtoMapping");
				e.printStackTrace();
			}
			return null;
		}
		
		if(object instanceof Change) {
			try {
				ChangeDTO changeDTO = changeAdapter.toDTO((Change) object);
				return (T) changeDTO;
			} catch(Exception e) {
				System.out.println("Failed in JpaDtoMapping");
				e.printStackTrace();
			}
			return null;
		}
		
		if(object instanceof Message) {
			try {
				MessageDTO messageDTO = messageAdapter.toDTO((Message) object);
				return (T) messageDTO;
			} catch(Exception e) {
				System.out.println("Failed in JpaDtoMapping");
				e.printStackTrace();
			}
			return null;
		}
		
		if(object instanceof MessageThread) {
			try {
				MessageThreadDTO messageThreadDTO = messageThreadAdapter.toDTO((MessageThread) object);
				return (T) messageThreadDTO;
			} catch(Exception e) {
				System.out.println("Failed in JpaDtoMapping");
				e.printStackTrace();
			}
			return null;
		}
		
		if(object instanceof MyUser) {
			try {
				MyUserDTO myUserDTO = myUserAdapter.toDTO((MyUser) object);
				return (T) myUserDTO;
			} catch(Exception e) {
				System.out.println("Failed in JpaDtoMapping");
				e.printStackTrace();
			}
			return null;
		}
		
		if(object instanceof PlowerCabinArea) {
			try {
				PlowerCabinAreaDTO plowerCabinAreaDTO = plowerCabinAreaAdapter.toDTO((PlowerCabinArea) object);
				return (T) plowerCabinAreaDTO;
			} catch(Exception e) {
				System.out.println("Failed in JpaDtoMapping");
				e.printStackTrace();
			}
			return null;
		}
		
		if(object instanceof PlowerPosition) {
			try {
				PlowerPositionDTO plowerPositionDTO = plowerPositionAdapter.toDTO((PlowerPosition) object);
				return (T) plowerPositionDTO;
			} catch(Exception e) {
				System.out.println("Failed in JpaDtoMapping");
				e.printStackTrace();
			}
			return null;
		}
		
		if(object instanceof PlowerRequest) {
			try {
				PlowerRequestDTO plowerRequestDTO = plowerRequestAdapter.toDTO((PlowerRequest) object);
				return (T) plowerRequestDTO;
			} catch(Exception e) {
				System.out.println("Failed in JpaDtoMapping");
				e.printStackTrace();
			}
			return null;
		}
		
		if(object instanceof PlowingRequest) {
			try {
				PlowingRequestDTO plowingRequestnDTO = plowingRequestAdapter.toDTO((PlowingRequest) object);
				return (T) plowingRequestnDTO;
			} catch(Exception e) {
				System.out.println("Failed in JpaDtoMapping");
				e.printStackTrace();
			}
			return null;
		}
		
		if(object instanceof SnowStatistic) {
			try {
				SnowStatisticDTO snowStatisticDTO = snowStatisticAdapter.toDTO((SnowStatistic) object);
				return (T) snowStatisticDTO;
			} catch(Exception e) {
				System.out.println("Failed in JpaDtoMapping");
				e.printStackTrace();
			}
			return null;
		}
		
		if(object instanceof WeatherStation) {
			try {
				WeatherStationDTO weatherStationDTO = weatherStationAdapter.toDTO((WeatherStation) object);
				return (T) weatherStationDTO;
			} catch(Exception e) {
				System.out.println("Failed in JpaDtoMapping");
				e.printStackTrace();
			}
			return null;
		}
		
		return null;
	}
	
	public <T> T fromDTO(Object object) {
		if(object instanceof CabinDTO) {
			try {
				Cabin cabin = cabinAdapter.fromDTO((CabinDTO) object);
				return (T) cabin;
			} catch(Exception e) {
				e.printStackTrace();
			}
			return null;
		}
		
		if(object instanceof CabinAreaDTO) {
			try {
				CabinArea cabinArea = cabinAreaAdapter.fromDTO((CabinAreaDTO) object);
				return (T) cabinArea;
			} catch(Exception e) {
				e.printStackTrace();
			}
			return null;
		}
		
		if(object instanceof ChangeDTO) {
			try {
				Change change = changeAdapter.fromDTO((ChangeDTO) object);
				return (T) change;
			} catch(Exception e) {
				e.printStackTrace();
			}
			return null;
		}
		
		if(object instanceof MessageDTO) {
			try {
				Message message = messageAdapter.fromDTO((MessageDTO) object);
				return (T) message;
			} catch(Exception e) {
				e.printStackTrace();
			}
			return null;
		}
		
		if(object instanceof MessageThreadDTO) {
			try {
				MessageThread messageThread = messageThreadAdapter.fromDTO((MessageThreadDTO) object);
				return (T) messageThread;
			} catch(Exception e) {
				e.printStackTrace();
			}
			return null;
		}
		
		if(object instanceof MyUserDTO) {
			try {
				MyUser myUser = myUserAdapter.fromDTO((MyUserDTO) object);
				return (T) myUser;
			} catch(Exception e) {
				e.printStackTrace();
			}
			return null;
		}
		
		if(object instanceof PlowerCabinAreaDTO) {
			try {
				PlowerCabinArea plowerCabinArea = plowerCabinAreaAdapter.fromDTO((PlowerCabinAreaDTO) object);
				return (T) plowerCabinArea;
			} catch(Exception e) {
				e.printStackTrace();
			}
			return null;
		}
		
		if(object instanceof PlowerPositionDTO) {
			try {
				PlowerPosition plowerPosition = plowerPositionAdapter.fromDTO((PlowerPositionDTO) object);
				return (T) plowerPosition;
			} catch(Exception e) {
				e.printStackTrace();
			}
			return null;
		}
		
		if(object instanceof PlowerRequestDTO) {
			try {
				PlowerRequest plowerRequest = plowerRequestAdapter.fromDTO((PlowerRequestDTO) object);
				return (T) plowerRequest;
			} catch(Exception e) {
				e.printStackTrace();
			}
			return null;
		}
		
		if(object instanceof PlowingRequestDTO) {
			try {
				PlowingRequest plowingRequestn = plowingRequestAdapter.fromDTO((PlowingRequestDTO) object);
				return (T) plowingRequestn;
			} catch(Exception e) {
				e.printStackTrace();
			}
			return null;
		}
		
		if(object instanceof SnowStatisticDTO) {
			try {
				SnowStatistic snowStatistic = snowStatisticAdapter.fromDTO((SnowStatisticDTO) object);
				return (T) snowStatistic;
			} catch(Exception e) {
				e.printStackTrace();
			}
			return null;
		}
		
		if(object instanceof WeatherStationDTO) {
			try {
				WeatherStation weatherStation = weatherStationAdapter.fromDTO((WeatherStationDTO) object);
				return (T) weatherStation;
			} catch(Exception e) {
				e.printStackTrace();
			}
			return null;
		}
		
		return null;
	}
}
