package com.snplog.backend.services.misc;

import java.util.Timer;

import javax.annotation.PostConstruct;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.snplog.backend.entity.CabinArea;
import com.snplog.backend.repository.CabinAreaRepository;
import com.snplog.backend.repository.SnowStatisticRepository;
import com.snplog.backend.repository.WeatherStationRepository;
import com.snplog.backend.thirdprtapi.WeatherData;
import com.snplog.backend.timertasks.WeatherHandler;
import com.snplog.backend.timertasks.WeatherStationHandler;

@Service
public class WeatherService {
	
	@Autowired
	private WeatherData weatherData;
	
	@Autowired
	private WeatherStationRepository weatherStationRepository;
	
	@Autowired
	private SnowStatisticRepository snowStatisticRepository;
	
	@Autowired
	private CabinAreaRepository cabinAreaRepository;
	
	private final int everyDay = 1000 * 60 * 60 * 24;
	
	private final int testCalls = 1000 * 30;
	 
	
	public WeatherService() {}
	
	public void addWeatherStation(CabinArea cabinArea) {
		try {
			Timer timer = new Timer();
			timer.schedule(new WeatherStationHandler(weatherData, cabinAreaRepository, weatherStationRepository, cabinArea), testCalls);
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	@PostConstruct
	public void updateSnowThickness() {
		try {
			Timer timer = new Timer();
			timer.scheduleAtFixedRate(new WeatherHandler(weatherStationRepository, snowStatisticRepository, weatherData), 1000 * 60 * 60 * 24, everyDay);

		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	
	
}
