package com.snplog.backend.singleton;

import java.util.ArrayList;
import java.util.List;

import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Service;

import com.google.maps.DirectionsApi;
import com.google.maps.DirectionsApiRequest;
import com.google.maps.GeoApiContext;
import com.google.maps.model.DirectionsResult;
import com.snplog.backend.models.RouteXLLocation;

@Service
@Scope(value = ConfigurableBeanFactory.SCOPE_SINGLETON)
public class DirectionsService {

	private GeoApiContext context;
	
	private final String API_KEY = "AIzaSyC9odZj0j7J4q5L_UKHrn_Ha2ygWZylPGM";
	
	public DirectionsService() {
		context = new GeoApiContext.Builder().apiKey(API_KEY).build();
	};
	
	public DirectionsResult getDirections(String origin, String destination, List<RouteXLLocation> locations) {
		DirectionsApiRequest req = DirectionsApi.newRequest(context)
				.origin(origin)
				.destination(destination)
				.waypoints(locationsToRequest(locations));
		
		try {
			DirectionsResult result = req.await();
			return result;
		} catch(Exception e) {
			e.printStackTrace();
		} 
		
		return null;
	}
	
	private String locationsToRequest(List<RouteXLLocation> locations) {
	    String result = "";
		
		for(int i = 0; i < locations.size(); i++) {
			result += locations.get(i).getLat() + "," + locations.get(i).getLng() + ((i < locations.size() - 1) ? "|" : "");
		}
		
		System.out.println(result);
		return result;
	}
	
}
