package com.snplog.backend.timertasks;

import java.io.IOException;
import java.util.TimerTask;

import org.apache.http.client.ClientProtocolException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.stereotype.Service;

import com.snplog.backend.entity.Cabin;
import com.snplog.backend.repository.CabinRepository;
import com.snplog.backend.services.misc.CabinPositionService;


public class CabinLocationHandler extends TimerTask {

	private Cabin cabin;
	
	
	private CabinRepository cabinRepository;
	
	private CabinPositionService cabinPositionService;
	
	
	
	public CabinLocationHandler(Cabin cabin, CabinRepository cabinRepository, CabinPositionService cabinPositionService) {
		this.cabin = cabin;
		this.cabinRepository = cabinRepository;
		this.cabinPositionService = cabinPositionService;
	}
	
	@Override
	public void run() {
		try {
			Cabin newCabin = cabinPositionService.getLongLatForCabin(cabin);
			cabinRepository.save(newCabin);
		} catch (ClientProtocolException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}

}
