package com.snplog.backend.timertasks;

import java.util.TimerTask;

import com.snplog.backend.entity.CabinArea;
import com.snplog.backend.entity.WeatherStation;
import com.snplog.backend.repository.CabinAreaRepository;
import com.snplog.backend.repository.WeatherStationRepository;
import com.snplog.backend.thirdprtapi.WeatherData;


public class WeatherStationHandler extends TimerTask{
	
	private WeatherData weatherData;
	
	private CabinAreaRepository cabinAreaRepository;
	
	private WeatherStationRepository weatherStationRepository;
	
	private CabinArea cabinArea;
	
	public WeatherStationHandler(
			WeatherData weatherData,
			CabinAreaRepository cabinAreaRepository,
			WeatherStationRepository weatherStationRepository,
			CabinArea cabinArea
			) {
		this.weatherData = weatherData;
		this.cabinAreaRepository = cabinAreaRepository;
		this.weatherStationRepository = weatherStationRepository;
		this.cabinArea = cabinArea;
	}

	@Override
	public void run() {
		try {
			// Gets nearest sensor
			WeatherStation weatherStation = weatherData.getNearestSensor(cabinArea.getLongitude(), cabinArea.getLatitude());
			// Checks if sensor exist in our db
			WeatherStation weatherStationExcisting = weatherStationRepository.getWeatherStationByFrostId(weatherStation.getFrostId());
			
			
			if(weatherStationExcisting != null) {
				// if it does just add it to the cabin area
				cabinArea.setNearestWeatherStation(weatherStationExcisting);
				cabinAreaRepository.save(cabinArea);
			} else {
				// if it doesnt add a new weather station
				weatherStationRepository.save(weatherStation);
				cabinArea.setNearestWeatherStation(weatherStation);
				cabinAreaRepository.save(cabinArea);
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
