import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:snow_plow/admin/PlowerRequestPage.dart';
import 'package:snow_plow/components/PlowerRequestCard.dart';
import 'package:snow_plow/globals.dart' as globals;
import 'package:snow_plow/models/PlowerRequestDTO.dart';
import 'package:snow_plow/services/PlowerRequestService.dart';
import 'package:snow_plow/widgets/main_drawer.dart';

class PlowerRequestsScreen extends StatefulWidget {
  static const routeName = "/PlowerRequestsScreen";

  @override
  _PlowerRequestsScreenState createState() => _PlowerRequestsScreenState();
}

class _PlowerRequestsScreenState extends State<PlowerRequestsScreen> {
  List<PlowerRequestDTO> plowerRequests = new List();

  PlowerRequestService plowerRequestService = new PlowerRequestService();

  PlowerRequestDTO plowerRequest = null;

  void fetchPlowerRequests() {
    plowerRequestService.fetchPlowerRequests().then((value) {
      setState(() {
        plowerRequests = value;
      });
    });
  }

  void onPlowerRequestPressed(PlowerRequestDTO plowerRequests) {
    globals.selectedPlowerRequest = plowerRequests;
    Navigator.of(context).pushNamed(PlowerRequestPage.routeName);
  }

  @override
  void initState() {
    plowerRequests = null;
    plowerRequest = null;
    globals.selectedPlowerRequest = null;
    fetchPlowerRequests();
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    if (plowerRequests == null) {
      return Scaffold(
        drawer: MainDrawer(),
        appBar: AppBar(
          title: Text("Plogerforespurslser"),
        ),
        body: Center(
          child: Text("Ingen nye ploger forespursler"),
        ),
      );
    } else {
      return Scaffold(
        drawer: MainDrawer(),
        appBar: AppBar(
          title: Text("Ploger forespursler"),
        ),
        body: new ListView.builder(
            padding: const EdgeInsets.symmetric(vertical: 8, horizontal: 0),
            itemCount: plowerRequests.length,
            itemBuilder: (BuildContext context, int index) {
              PlowerRequestDTO plowerRequest = plowerRequests.elementAt(index);
              return ListBody(
                children: <Widget>[
                  new PlowerRequestCardComponent(
                      plowerRequest: plowerRequest,
                      onPlowerRequestPressed: onPlowerRequestPressed)
                ],
              );
            }),
      );
    }
  }
}
