import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:snow_plow/models/CabinAreaDTO.dart';

class CabinAreaCardComponent extends StatelessWidget {
  final CabinAreaDTO cabinArea;
  Function(CabinAreaDTO cabinArea) onCabinAreaPressed;

  CabinAreaCardComponent({this.cabinArea, this.onCabinAreaPressed});

  @override
  Widget build(BuildContext context) {
    return Card(
      child: ListTile(
        onTap: () => onCabinAreaPressed(cabinArea),
        contentPadding: EdgeInsets.all(10),
        leading: Icon(
          Icons.home,
          color: Colors.teal,
          size: 50.0,
        ),
        title: Text(
          (cabinArea?.name ?? ""),
          style: TextStyle(
            color: Colors.teal,
            fontSize: 25,
          ),
        ),
        subtitle: Text(
          (cabinArea?.latitude?.toString() ?? "") +
              ", " +
              (cabinArea?.longitude?.toString() ?? "") +
              ", " +
              (cabinArea?.id?.toString() ?? ""),
          style: TextStyle(color: Colors.teal, fontSize: 20),
        ),
        isThreeLine: true,
      ),
    );
  }
}
