import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:snow_plow/models/CabinDTO.dart';

class CardComponent extends StatelessWidget {
  final CabinDTO cabin;
  Function(CabinDTO cabin) onCabinPressed;

  CardComponent({this.cabin, this.onCabinPressed});

  @override
  Widget build(BuildContext context) {
    return Card(
      child: ListTile(
        onTap: () => onCabinPressed(cabin),
        contentPadding: EdgeInsets.all(10),
        leading: Icon(
          Icons.home,
          color: Colors.teal,
          size: 50.0,
        ),
        title: Text(
          (cabin?.cabinName ?? ""),
          style: TextStyle(
            color: Colors.teal,
            fontSize: 25,
          ),
        ),
        subtitle: Text(
          (cabin?.country ?? "") +
              ", " +
              (cabin?.municipality ?? "") +
              ", " +
              (cabin?.streetAdress ?? ""),
          style: TextStyle(color: Colors.teal, fontSize: 20),
        ),
        isThreeLine: true,
      ),
    );
  }
}
