import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:intl/intl.dart';
import 'package:snow_plow/models/PlowerRequestDTO.dart';

class PlowerRequestCardComponent extends StatelessWidget {
  final PlowerRequestDTO plowerRequest;
  Function(PlowerRequestDTO plowerRequest) onPlowerRequestPressed;

  PlowerRequestCardComponent({this.plowerRequest, this.onPlowerRequestPressed});

  @override
  Widget build(BuildContext context) {
    return Card(
      child: ListTile(
        onTap: () => onPlowerRequestPressed(plowerRequest),
        contentPadding: EdgeInsets.all(10),
        leading: Icon(
          Icons.home,
          color: Colors.teal,
          size: 50.0,
        ),
        title: Text(
          (plowerRequest?.myUser?.firstName ?? ""),
          style: TextStyle(
            color: Colors.teal,
            fontSize: 25,
          ),
        ),
        subtitle: Text(
          (plowerRequest?.myUser?.email ?? "") +
              ", " +
              (plowerRequest?.myUser?.phoneNumber ?? "") +
              ", " +
              (plowerRequest?.dateRequested != null
                  ? DateFormat("dd-MM-yyyy - kk:mm")
                      .format(plowerRequest.dateRequested)
                  : "No date"),
          style: TextStyle(color: Colors.teal, fontSize: 20),
        ),
        isThreeLine: true,
      ),
    );
  }
}
