import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:intl/intl.dart';
import 'package:snow_plow/models/PlowingRequestDTO.dart';

class PlowingRequestCardComponent extends StatelessWidget {
  final PlowingRequestDTO plowingRequest;
  Function(PlowingRequestDTO plowingRequestDTO) onPlowingRequestLongPress;

  PlowingRequestCardComponent(
      {this.plowingRequest, this.onPlowingRequestLongPress});

  @override
  Widget build(BuildContext context) {
    return Card(
      child: ListTile(
        onLongPress: () => onPlowingRequestLongPress(plowingRequest),
        contentPadding: EdgeInsets.all(10),
        leading: Icon(
          Icons.calendar_today,
          color: Colors.teal,
          size: 25.0,
        ),
        title: Text(
          (plowingRequest?.completed ?? ""),
          style: TextStyle(
            color: Colors.teal,
            fontSize: 25,
          ),
        ),
        subtitle: Text(
          "Arrival: " +
              (plowingRequest?.dateOfArrival != null
                  ? DateFormat("dd-MM-yyyy - kk:mm")
                      .format(plowingRequest.dateOfArrival)
                  : "No date") +
              "\n" +
              "Departure: " +
              (plowingRequest?.dateOfDeparture != null
                  ? DateFormat("dd-MM-yyyy - kk:mm")
                      .format(plowingRequest.dateOfDeparture)
                  : "No date"),
          style: TextStyle(color: Colors.teal, fontSize: 20),
        ),
        isThreeLine: true,
      ),
    );
  }
}
