import 'package:flutter/material.dart';

class InputForm extends StatefulWidget {
  final TextEditingController inputController;
  final String label;
  final TextInputType textInputType;

  InputForm({
    TextEditingController inputController,
    String label,
    TextInputType textInputType,
  })  : this.inputController = inputController,
        this.label = label,
        this.textInputType = textInputType;

  _InputFormState createState() =>
      _InputFormState(inputController, label, textInputType);
}

class _InputFormState extends State<InputForm> {
  TextEditingController inputController;
  String label;
  TextInputType textInputType;

  _InputFormState(this.inputController, this.label, this.textInputType);

  @override
  Widget build(BuildContext context) {
    return Container(
      child: Column(
        children: <Widget>[
          Container(
            padding: EdgeInsets.fromLTRB(50, 15, 50, 0),
            child: Align(
              alignment: Alignment.centerLeft,
              child: Text(
                label,
                style: Theme.of(context).textTheme.subtitle,
              ),
            ),
          ),
          Container(
            padding: EdgeInsets.fromLTRB(50, 0, 50, 0),
            child: TextField(
              keyboardType: textInputType,
              controller: inputController,
              textAlign: TextAlign.left,
              decoration: new InputDecoration(
                hintText: "",
              ),
            ),
          ),
        ],
      ),
    );
  }
}
