import 'package:flutter/material.dart';
import 'package:flutter_localizations/flutter_localizations.dart';
import 'package:provider/provider.dart';
import 'package:snow_plow/Plower/CabinAreas.dart';
import 'package:snow_plow/Plower/NewPlowerCabinAreaPage.dart';
import 'package:snow_plow/admin/PlowerRequestPage.dart';
import 'package:snow_plow/admin/PlowerRequests.dart';
import 'package:snow_plow/cabins/CabinPage.dart';
import 'package:snow_plow/cabins/add_cabin.dart';
import 'package:snow_plow/login/login_confirmation.dart';
import 'package:snow_plow/login/registration.dart';
import 'package:snow_plow/map/map_view.dart';
import 'package:snow_plow/profile/edit_profile.dart';
import 'package:snow_plow/profile/profile.dart';
import 'package:snow_plow/screens/MyCabinsScreen.dart';
import 'package:snow_plow/test/TestPage.dart';

import './login/login.dart';
import './providers/cabin_provider.dart';
import 'Plower/CabinArea.dart';

// Run MyApp.
void main() => runApp(MyApp());

// Generate the layout for MyApp
class MyApp extends StatelessWidget {
  final Locale locale = Locale("nb");

  @override
  Widget build(BuildContext context) {
    return ChangeNotifierProvider(
      builder: (ctx) => CabinProvider(),
      child: MaterialApp(
        localizationsDelegates: [
          GlobalMaterialLocalizations.delegate,
          GlobalWidgetsLocalizations.delegate
        ],
        supportedLocales: [const Locale('nb'), const Locale('nn')],
        title: "flutter app",
        theme: ThemeData(
          primarySwatch: Colors.teal,
          accentColor: Colors.teal[200],
          fontFamily: "",
        ),
        home: LoginPage(),
        routes: {
          LoginPage.routeName: (ctx) => LoginPage(),
          LoginConfirmationPage.routeName: (ctx) => LoginConfirmationPage(),
          RegistrationPage.routeName: (ctx) => RegistrationPage(),
          ProfilePage.routeName: (ctx) => ProfilePage(),
          ProfileEditPage.routeName: (ctx) => ProfileEditPage(),
          PlowerMapView.routeName: (ctx) => PlowerMapView(),
          NewCabinPage.routeName: (ctx) => NewCabinPage(),
          testPage.routeName: (ctx) => testPage(),
          MyCabinsScreen.routeName: (ctx) => MyCabinsScreen(),
          MyCabinAreasScreen.routeName: (ctx) => MyCabinAreasScreen(),
          CabinPage.routeName: (ctx) => CabinPage(),
          CabinAreaPage.routeName: (ctx) => CabinAreaPage(),
          NewPlowerCabinAreaPage.routeName: (ctx) => NewPlowerCabinAreaPage(),
          PlowerRequestsScreen.routeName: (ctx) => PlowerRequestsScreen(),
          PlowerRequestPage.routeName: (ctx) => PlowerRequestPage(),
        },
      ),
    );
  }
}
