import 'package:flutter/material.dart';
import 'package:snow_plow/models/CabinDTO.dart';

class PlowerCabinInfo extends StatefulWidget {
  final CabinDTO cabin;

  PlowerCabinInfo({CabinDTO cabin}) : this.cabin = cabin;

  _PlowerCabinInfoState createState() => _PlowerCabinInfoState(cabin);
}

class _PlowerCabinInfoState extends State<PlowerCabinInfo> {
  CabinDTO cabin;

  _PlowerCabinInfoState(this.cabin);

  _sendPlowedConfirmation() {}

  @override
  Widget build(BuildContext context) {
    return Container(
      padding: EdgeInsets.fromLTRB(10, 10, 10, 10),
      color: Colors.white,
      child: Row(
        children: <Widget>[
          Container(
            padding: EdgeInsets.fromLTRB(10, 0, 10, 0),
            child: Icon(
              Icons.home,
              size: 48,
              color: Colors.red,
            ),
          ),
          Container(
            padding: EdgeInsets.fromLTRB(10, 0, 10, 0),
            height: 50,
            child: Column(
              children: <Widget>[
                Text(
                  cabin.cabinName,
                  style: Theme.of(context).textTheme.body1,
                ),
                Text(
                  cabin.streetAdress,
                  style: Theme.of(context).textTheme.body1,
                ),
              ],
            ),
          ),
          Container(
            padding: EdgeInsets.fromLTRB(10, 0, 10, 0),
            child: RaisedButton(
              child: Icon(
                Icons.check_circle_outline,
                color: Colors.white,
              ),
              color: Theme.of(context).primaryColor,
              splashColor: Colors.white,
              onPressed: _sendPlowedConfirmation,
            ),
          ),
        ],
      ),
    );
  }
}
