import 'Change.dart';

class CabinAreaDTO {
  int id;
  String name;
  DateTime created;
  double longitude;
  double latitude;
  int radius;
  bool edited = false;
  List<Change> changes;

  CabinAreaDTO(
      {this.id,
      this.name,
      this.created,
      this.longitude,
      this.latitude,
      this.radius});

  factory CabinAreaDTO.fromJson(Map<String, dynamic> json) {
    if (json != null) {
      if (json.containsKey("id")) {
        return CabinAreaDTO(
            id: json["id"],
            name: json["name"],
            created: new DateTime.fromMillisecondsSinceEpoch(json["created"]),
            longitude: json["longitude"],
            latitude: json["latitude"],
            radius: json["radius"]);
      }
    }
    return null;
  }

  Map<String, dynamic> toJson() => {
        "id": id,
        "name": name,
        "created": created != null ? created.toIso8601String() : null,
        "longitude": longitude,
        "latitude": latitude,
        "radius": radius,
        "edited": edited,
        "changes":
            edited ? changes.map((change) => change.toJson).toList() : null
      };

  @override
  String toString() {
    return 'CabinAreaDTO{id: $id, name: $name, created: $created, longitude: $longitude, latitude: $latitude, radius: $radius}';
  }
}
