import 'CabinAreaDTO.dart';
import 'Change.dart';
import 'MyUserDTO.dart';

class CabinDTO {
  int id;
  MyUserDTO myUser;
  CabinAreaDTO cabinArea;
  String cabinName;
  double longitude;
  double latitude;
  String country;
  String region;
  String municipality;
  String streetAdress;
  int kid;
  int gid;
  int bid;
  String cabinStatus;
  DateTime lastPlowed;
  DateTime created;
  bool edited = false;
  List<Change> changes;

//Constructor
  CabinDTO(
      {this.id,
      this.myUser,
      this.cabinArea,
      this.cabinName,
      this.longitude,
      this.latitude,
      this.country,
      this.region,
      this.municipality,
      this.streetAdress,
      this.kid,
      this.gid,
      this.bid,
      this.cabinStatus,
      this.lastPlowed,
      this.created});

  factory CabinDTO.fromJson(Map<String, dynamic> json) {
    if (json != null) {
      if (json.containsKey("id")) {
        return CabinDTO(
            id: json["id"],
            myUser: json["myUserDTO"] != null
                ? MyUserDTO.fromJson(json["myUserDTO"])
                : null,
            cabinArea: json["cabinArea"] != null
                ? CabinAreaDTO.fromJson(json["cabinArea"])
                : null,
            cabinName: json["cabinName"],
            longitude: json["longitude"],
            latitude: json["latitude"],
            country: json["country"],
            region: json["region"],
            municipality: json["municipality"],
            streetAdress: json["streetAdress"],
            kid: json["kid"],
            gid: json["gid"],
            bid: json["bid"],
            cabinStatus: json["cabinStatus"],
            lastPlowed: json['lastPlowed'] != null
                ? new DateTime.fromMillisecondsSinceEpoch(json['lastPlowed'])
                : null,
            created: json['created'] != null
                ? new DateTime.fromMillisecondsSinceEpoch(json['created'])
                : null);
      }
    }
    return null;
  }

  Map<String, dynamic> toJson() => {
        "id": id,
        "cabinOwner": myUser.toJson(),
        "cabinArea": cabinArea.toJson(),
        "cabinName": cabinName,
        "longitude": longitude,
        "latitude": latitude,
        "country": country,
        "region": region,
        "municipality": municipality,
        "streetAdress": streetAdress,
        "kid": kid,
        "gid": gid,
        "bid": bid,
        "cabinStatus": cabinStatus,
        "lastPlowed": lastPlowed != null ? lastPlowed.toIso8601String() : null,
        "created": created != null ? created.toIso8601String() : null,
        "edited": edited,
        "changes":
            edited ? changes.map((change) => change.toJson).toList() : null
      };

  @override
  String toString() {
    return 'CabinDTO{id: $id, myUserDTO: $myUser, cabinAreaDTO: $cabinArea, cabinName: $cabinName, longitude: $longitude, latitude: $latitude, country: $country, region: $region, municipality: $municipality, streetAdress: $streetAdress, kid: $kid, gid: $gid, bid: $bid, cabinStatus: $cabinStatus, lastPlowed: $lastPlowed, created: $created}';
  }
}
