import 'package:snow_plow/models/MyUserDTO.dart';

import 'Change.dart';
import 'MessageThreadDTO.dart';

class MessageDTO {
  int id;
  MyUserDTO sender;
  MessageThreadDTO messageThreadDTO;
  String messageContent;
  DateTime messageCreated;
  bool edited = false;
  List<Change> changes;

  MessageDTO(
      {this.id,
      this.sender,
      this.messageThreadDTO,
      this.messageContent,
      this.messageCreated});

  factory MessageDTO.fromJson(Map<String, dynamic> json) {
    if (json == null) {
      return null;
    }
    return MessageDTO(
        id: json['id'],
        sender: MyUserDTO.fromJson(json['sender']),
        messageThreadDTO: MessageThreadDTO.fromJson(json['messageThreadDTO']),
        messageContent: json['messageContent'],
        messageCreated:
            new DateTime.fromMillisecondsSinceEpoch(json['messageCreated']));
  }

  Map<String, dynamic> toJson() => {
        "id": id,
        "sender": sender.toJson,
        "messageThreadDTO": messageThreadDTO.toJson,
        "messageContent": messageContent,
        "messageCreated": messageCreated,
        "edited": edited,
        "changes": changes.map((change) => change.toJson).toList()
      };

  @override
  String toString() {
    return 'MessageDTO{id: $id, sender: $sender, messageThreadDTO: $messageThreadDTO, messageContent: $messageContent, messageCreated: $messageCreated, edited: $edited, changes: $changes}';
  }
}
