import 'package:snow_plow/models/MyUserDTO.dart';

import 'Change.dart';

class MessageThreadDTO {
  int id;
  DateTime dateCreated;
  bool closed;
  DateTime dateClosed;
  List<MyUserDTO> participants;
  bool edited = false;
  List<Change> changes;

  MessageThreadDTO(
      {this.id,
      this.dateCreated,
      this.closed,
      this.dateClosed,
      this.participants});

  factory MessageThreadDTO.fromJson(Map<String, dynamic> json) {
    if (json == null) {
      return null;
    }
    return MessageThreadDTO(
        id: json['id'],
        dateCreated:
            new DateTime.fromMillisecondsSinceEpoch(json['dateCreated']),
        closed: json[""],
        dateClosed: new DateTime.fromMillisecondsSinceEpoch(json['dateClosed']),
        participants: json['participants']
            .map<MyUserDTO>((json) => MyUserDTO.fromJson(json))
            .toList());
  }

  Map<String, dynamic> toJson() => {
        "id": id,
        "dateCreated": dateCreated,
        "closed": closed,
        "dateClosed": dateClosed,
        "participants": participants.map((participant) => participant.toJson()),
        "edited": edited,
        "changes": changes.map((change) => change.toJson).toList()
      };

  @override
  String toString() {
    return 'MessageThreadDTO{id: $id, dateCreated: $dateCreated, closed: $closed, dateClosed: $dateClosed, participants: $participants, edited: $edited, changes: $changes}';
  }
}
