import 'package:snow_plow/services/RoleService.dart';

import 'CabinDTO.dart';
import 'Change.dart';
import 'RoleDTO.dart';

class MyUserDTO {
  int id;
  String firstName;
  String lastName;
  String email;
  String phoneNumber;
  String streetAdress;
  String city;
  String country;
  DateTime dateTimeCreated;
  List<RoleDTO> roleDTOs;
  List<CabinDTO> cabinDTOs;
  bool edited = false;
  List<Change> changes = new List();

  RoleService roleService = new RoleService();

  MyUserDTO(
      {this.id,
      this.firstName,
      this.lastName,
      this.email,
      this.phoneNumber,
      this.streetAdress,
      this.city,
      this.country,
      this.dateTimeCreated,
      this.roleDTOs,
      this.cabinDTOs});

  factory MyUserDTO.fromJson(Map<String, dynamic> json) {
    if (json != null) {
      if (json.containsKey("id")) {
        return MyUserDTO(
            id: json['id'],
            firstName: json['firstName'],
            lastName: json['lastName'],
            email: json['email'],
            phoneNumber: json['phoneNumber'],
            streetAdress: json['streetAdress'],
            city: json['city'],
            country: json['country'],
            dateTimeCreated: new DateTime.fromMillisecondsSinceEpoch(
                json['dateTimeCreated']),
            roleDTOs: json['roles'] != null
                ? json['roles']
                    .map<RoleDTO>((json) => RoleDTO.fromJson(json))
                    .toList()
                : null,
            cabinDTOs: json['cabins'] != null
                ? json['cabins']
                    .map<CabinDTO>((json) => CabinDTO.fromJson(json))
                    .toList()
                : null);
      }
    }
    return null;
  }

  Map<String, dynamic> toJson() => {
        "id": id,
        "firstName": firstName,
        "lastName": lastName,
        "email": email,
        "phoneNumber": phoneNumber,
        "city": city,
        "country": country,
        "streetAdress": streetAdress,
        "roles": roleDTOs != null
            ? roleDTOs.map((role) => role.toJson()).toList()
            : null,
        "dateTimeCreated":
            dateTimeCreated != null ? dateTimeCreated.toIso8601String() : null,
        "edited": edited,
        "changes":
            edited ? changes.map((change) => change.toJson()).toList() : null
      };

  // changes.map((change) => change.toJson).toList()
  @override
  String toString() {
    return 'MyUserDTO{id: $id, firstName: $firstName, lastName: $lastName, email: $email, phoneNumber: $phoneNumber, streetAdress: $streetAdress, city: $city, country: $country, dateTimeCreated: $dateTimeCreated, roleDTOs: $roleDTOs, cabinDTOs: $cabinDTOs, roleService: $roleService}';
  }
}
