import 'package:snow_plow/models/CabinAreaDTO.dart';
import 'package:snow_plow/models/MyUserDTO.dart';

import 'Change.dart';

class PlowerCabinAreaDTO {
  int id;
  MyUserDTO plower;
  CabinAreaDTO cabinArea;
  bool valid;
  DateTime dateCreated;
  DateTime dateEnded;
  bool edited = false;
  List<Change> changes;

  PlowerCabinAreaDTO(
      {this.id,
      this.plower,
      this.cabinArea,
      this.valid,
      this.dateCreated,
      this.dateEnded});

  factory PlowerCabinAreaDTO.fromJson(Map<String, dynamic> json) {
    if (json == null) {
      return null;
    }
    return PlowerCabinAreaDTO(
      id: json['id'],
      plower:
          json["plower"] != null ? MyUserDTO.fromJson(json["plower"]) : null,
      cabinArea: json["cabinArea"] != null
          ? CabinAreaDTO.fromJson(json["cabinArea"])
          : null,
      valid: json["valid"],
      dateCreated: json["dateCreated"] != null
          ? new DateTime.fromMillisecondsSinceEpoch(json["dateCreated"])
          : null,
      dateEnded: json["dateEnded"] != null
          ? new DateTime.fromMillisecondsSinceEpoch(json["dateEnded"])
          : null,
    );
  }

  Map<String, dynamic> toJson() => {
        "id": id,
        "plower": plower != null ? plower.toJson() : null,
        "cabinArea": cabinArea != null ? cabinArea.toJson() : null,
        "valid": valid,
        "dateCreated":
            dateCreated != null ? dateCreated.toIso8601String() : null,
        "dateEnded": dateEnded != null ? dateEnded.toIso8601String() : null,
        "edited": edited,
        "changes":
            edited ? changes.map((change) => change.toJson()).toList() : null
      };

  @override
  String toString() {
    return 'PlowerCabinAreaDTO{id: $id, plower: $plower, cabinArea: $cabinArea, valid: $valid, dateCreated: $dateCreated, dateEnded: $dateEnded}';
  }
}
