import 'package:snow_plow/models/MyUserDTO.dart';

class PlowerPositionDTO {
  int id;
  MyUserDTO plower;
  DateTime datetime;
  double latitude;
  double longitude;

  PlowerPositionDTO(
      {this.id, this.plower, this.datetime, this.latitude, this.longitude});

  factory PlowerPositionDTO.fromJson(Map<String, dynamic> json) {
    if (json == null) {
      return null;
    }
    return PlowerPositionDTO(
        id: json['id'],
        plower: MyUserDTO.fromJson(json["plower"]),
        datetime: new DateTime.fromMillisecondsSinceEpoch(json['datetime']),
        latitude: json["latitude"],
        longitude: json["longitude"]);
  }

  Map<String, dynamic> toJson() => {
        "id": id,
        "plower": plower.toJson(),
        "datetime": datetime,
        "latitude": latitude,
        "longitude": longitude
      };

  @override
  String toString() {
    return 'PlowerPositionDTO{id: $id, plower: $plower, datetime: $datetime, latitude: $latitude, longitude: $longitude}';
  }
}
