import 'package:snow_plow/models/MyUserDTO.dart';

import 'Change.dart';

class PlowerRequestDTO {
  int id;
  MyUserDTO myUser;
  DateTime dateRequested;
  DateTime dateResponded;
  bool status;
  bool edited = false;
  List<Change> changes = new List();

  PlowerRequestDTO(
      {this.id,
      this.myUser,
      this.dateRequested,
      this.dateResponded,
      this.status});

  factory PlowerRequestDTO.fromJson(Map<String, dynamic> json) {
    if (json != null) {
      if (json.containsKey("id")) {
        return PlowerRequestDTO(
            id: json['id'],
            myUser: json["myUser"] != null
                ? MyUserDTO.fromJson(json["myUser"])
                : null,
            dateRequested: json["dateRequested"] != null
                ? new DateTime.fromMillisecondsSinceEpoch(json['dateRequested'])
                : null,
            dateResponded: json["dateResponded"] != null
                ? new DateTime.fromMillisecondsSinceEpoch(json['dateResponded'])
                : null,
            status: json["status"]);
      }
    }
    return null;
  }

  Map<String, dynamic> toJson() => {
        "id": id,
        "plower": myUser.toJson(),
        "dateRequested":
            dateRequested != null ? dateRequested.toIso8601String() : null,
        "dateResponded":
            dateResponded != null ? dateResponded.toIso8601String() : null,
        "status": status,
        "edited": edited,
        "changes":
            edited ? changes.map((change) => change.toJson()).toList() : null
      };

  @override
  String toString() {
    return 'PlowerRequestDTO{id: $id, myUser: $myUser, dateRequested: $dateRequested, dateResponded: $dateResponded, status: $status, edited: $edited, changes: $changes}';
  }
}
