import 'package:snow_plow/models/CabinAreaDTO.dart';

import 'CabinDTO.dart';
import 'Change.dart';

class PlowingRequestDTO {
  int id;
  CabinDTO cabin;
  CabinAreaDTO cabinArea;
  DateTime dateOfArrival;
  DateTime dateOfDeparture;
  DateTime dateRequested;
  DateTime dateCompleted;
  bool completed;
  String description;
  bool edited = false;
  List<Change> changes = new List();

  PlowingRequestDTO(
      {this.id,
      this.cabin,
      this.cabinArea,
      this.dateOfArrival,
      this.dateOfDeparture,
      this.dateRequested,
      this.dateCompleted,
      this.completed,
      this.description});

  factory PlowingRequestDTO.fromJson(Map<String, dynamic> json) {
    if (json != null) {
      if (json.containsKey("id"))
        return PlowingRequestDTO(
            id: json['id'],
            cabin:
                json["cabin"] != null ? CabinDTO.fromJson(json["cabin"]) : null,
            cabinArea: json["cabinArea"] != null
                ? CabinAreaDTO.fromJson(json["cabinArea"])
                : null,
            dateOfArrival: json['dateOfArrival'] != null
                ? new DateTime.fromMillisecondsSinceEpoch(json['dateOfArrival'])
                : null,
            dateOfDeparture: json['dateOfDeparture'] != null
                ? new DateTime.fromMillisecondsSinceEpoch(
                    json['dateOfDeparture'])
                : null,
            dateRequested: json['dateRequested'] != null
                ? new DateTime.fromMillisecondsSinceEpoch(json['dateRequested'])
                : null,
            dateCompleted: json['dateCompleted'] != null
                ? new DateTime.fromMillisecondsSinceEpoch(json['dateCompleted'])
                : null,
            description: json["description"]);
    }
    return null;
  }

  Map<String, dynamic> toJson() => {
        "id": id,
        "cabin": cabin?.toJson(),
        "cabinArea": cabinArea?.toJson(),
        "dateOfArrival": dateOfArrival?.toIso8601String(),
        "dateOfDeparture": dateOfDeparture?.toIso8601String(),
        "dateRequested": dateRequested?.toIso8601String(),
        "dateCompleted": dateCompleted?.toIso8601String(),
        "completed": completed,
        "description": description,
        "edited": edited,
        "changes":
            edited ? changes.map((change) => change.toJson()).toList() : null
      };

  @override
  String toString() {
    return 'PlowingRequestDTO{id: $id, cabin: $cabin, cabinArea: $cabinArea, dateOfArrival: $dateOfArrival, dateOfDeparture: $dateOfDeparture, dateRequested: $dateRequested, dateCompleted: $dateCompleted, completed: $completed, description: $description, edited: $edited, changes: $changes}';
  }
}
