import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:snow_plow/cabins/CabinPage.dart';
import 'package:snow_plow/cabins/add_cabin.dart';
import 'package:snow_plow/components/CardComponent.dart';
import 'package:snow_plow/globals.dart' as globals;
import 'package:snow_plow/models/CabinDTO.dart';
import 'package:snow_plow/services/CabinService.dart';
import 'package:snow_plow/widgets/main_drawer.dart';

class MyCabinsScreen extends StatefulWidget {
  static const routeName = "/MyCabinsScreen";

  @override
  _MyCabinsScreenState createState() => _MyCabinsScreenState();
}

class _MyCabinsScreenState extends State<MyCabinsScreen> {
  List<CabinDTO> cabins;

  CabinService cabinService = new CabinService();

  CabinDTO cabin = null;

  void fetchCabins() {
    cabinService.fetchMyCabins().then((value) {
      setState(() {
        cabins = value;
      });
    });
  }

  void onCabinPressed(CabinDTO cabin) {
    globals.selectedCabin = cabin;
    Navigator.of(context).pushNamed(CabinPage.routeName);
  }

  void onAddCabinPress() {
    Navigator.of(context).pushNamed(NewCabinPage.routeName);
  }

  @override
  void initState() {
    cabin = null;
    globals.selectedCabin = null;
    fetchCabins();
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    if (cabins == null) {
      return Scaffold(
        drawer: MainDrawer(),
        appBar: AppBar(
          title: Text("Mine Hytter"),
        ),
        body: Center(
          child: Text(
              "Ingen hytter lagt til, trykk på pluss knappen for å legge til"),
        ),
        floatingActionButton: FloatingActionButton(
          onPressed: onAddCabinPress,
          child: Icon(
            Icons.add,
            size: 50,
            color: Colors.white,
          ),
        ),
      );
    } else {
      return Scaffold(
        drawer: MainDrawer(),
        appBar: AppBar(
          title: Text("Mine Hytter"),
        ),
        body: new ListView.builder(
            padding: const EdgeInsets.symmetric(vertical: 8, horizontal: 0),
            itemCount: cabins.length,
            itemBuilder: (BuildContext context, int index) {
              CabinDTO cabin = cabins.elementAt(index);
              return ListBody(
                children: <Widget>[
                  new CardComponent(
                      cabin: cabin, onCabinPressed: onCabinPressed)
                ],
              );
            }),
        floatingActionButton: FloatingActionButton(
          onPressed: onAddCabinPress,
          child: Icon(
            Icons.add,
            size: 50,
            color: Colors.white,
          ),
        ),
      );
    }
  }
}
