import 'dart:convert';
import 'dart:io';

import 'package:flutter_polyline_points/flutter_polyline_points.dart';
import 'package:google_maps_flutter/google_maps_flutter.dart';
import 'package:http/http.dart' as http;
import 'package:snow_plow/globals.dart' as globals;
import 'package:snow_plow/models/RouteRequest.dart';

class RouteService {
  Future<List<LatLng>> fetchRoute(RouteRequest request) async {
    Map<String, String> headers = {
      HttpHeaders.authorizationHeader: "Bearer " + globals.jsonWebToken.token,
      HttpHeaders.acceptHeader: "application/json",
      HttpHeaders.contentTypeHeader: "application/json"
    };
    final body = jsonEncode(request.toJson());
    final response = await http.post(globals.baseUrl + "/route/optimalroute",
        headers: headers, body: body);
    if (response.statusCode == 200) {
      print("sucess");
      PolylinePoints polylinePoints = PolylinePoints();
      final data = jsonDecode(response.body);
      List<PointLatLng> pointList = polylinePoints
          .decodePolyline(data["routes"][0]["overviewPolyline"]["encodedPath"]);
      List<LatLng> latLngList = new List();
      pointList.forEach((PointLatLng point) {
        latLngList.add(LatLng(point.latitude, point.longitude));
      });
      return latLngList;
    } else {
      print("cabins not found");
      return null;
    }
  }
}
